use crate::util::surrealdb::schemas;
use leptos::*;

/// Renders the home page of your application.
#[component]
pub fn Participants() -> impl IntoView {
    let participants_context = use_context::<schemas::ParticipantsContext>().unwrap();

    view! {
        <div class="participants-container">
            <table>
                <tr>
                    <th>"Naam"</th>
                    <th>"Groep"</th>
                    <th>"Lifesaver"</th>
                    <th>"Hindernis"</th>
                    <th>"Popduiken"</th>
                </tr>
                <For
                    each=move || participants_context.get()
                    key=|state| state.id.clone()
                    let:child
                >
                    <tr>
                        <td>{ move || child.value.get().name }</td>
                        <td>{ move || child.value.get().group }</td>
                        { move || match child.value.get().events {
                                Some(events) => view! {
                                    <td>{ events.lifesaver.unwrap_or(0) }</td>
                                    <td>{ events.hindernis.unwrap_or(0) }</td>
                                    <td>{ events.popduiken.unwrap_or(0) }</td>
                                },
                                None => view! {
                                    <td>"0"</td>
                                    <td>"0"</td>
                                    <td>"0"</td>
                                }
                            }
                        }
                    </tr>
                </For>
            </table>
        </div>
    }
}
