cfg_if::cfg_if! {
    if #[cfg(feature = "ssr")] {
        use surrealdb::sql::Thing;
    }
}

use leptos::RwSignal;
use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize, Debug, Clone, PartialEq, Hash, Eq)]
pub struct Events {
    pub lifesaver: Option<u32>,
    pub hindernis: Option<u32>,
    pub popduiken: Option<u32>,
}

#[cfg(feature = "ssr")]
#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct ParticipantRecord {
    pub id: Thing,
    pub name: String,
    pub group: String,
    pub events: Option<Events>,
}

#[derive(Serialize, Deserialize, Debug, Clone, PartialEq)]
pub struct Participant {
    pub id: String,
    pub name: String,
    pub group: String,
    pub events: Option<Events>,
}

#[derive(Serialize, Deserialize, Debug, Clone)]
pub struct ParticipantSignal {
    pub id: String,
    pub value: RwSignal<Participant>,
}

pub type ParticipantsContext = RwSignal<Vec<ParticipantSignal>>;

#[derive(Serialize, Deserialize, Debug)]
pub struct NewParticipant {
    pub name: String,
    pub group: String,
}
